diff --git a/web/pgadmin/dashboard/static/js/dashboard.js b/web/pgadmin/dashboard/static/js/dashboard.js
index bb2503feb..b854823cc 100644
--- a/web/pgadmin/dashboard/static/js/dashboard.js
+++ b/web/pgadmin/dashboard/static/js/dashboard.js
@@ -9,12 +9,12 @@
 
 define('pgadmin.dashboard', [
   'sources/url_for', 'sources/gettext', 'require', 'jquery', 'underscore',
-  'sources/pgadmin', 'backbone', 'backgrid', './charting',
+  'sources/pgadmin', 'backbone', 'backgrid',
   'pgadmin.alertifyjs', 'pgadmin.backform', 'sources/nodes/dashboard',
-  'sources/utils', 'sources/window', 'pgadmin.browser', 'bootstrap', 'wcdocker',
+  'sources/window', './ChartsDOM', 'pgadmin.browser', 'bootstrap', 'wcdocker',
 ], function(
-  url_for, gettext, r, $, _, pgAdmin, Backbone, Backgrid, charting,
-  Alertify, Backform, NodesDashboard, commonUtils, pgWindow
+  url_for, gettext, r, $, _, pgAdmin, Backbone, Backgrid,
+  Alertify, Backform, NodesDashboard, pgWindow, ChartsDOM
 ) {
 
   pgAdmin.Browser = pgAdmin.Browser || {};
@@ -203,6 +203,7 @@ define('pgadmin.dashboard', [
         return;
 
       this.initialized = true;
+      this.chartsDomObj = null;
 
       this.sid = this.did = -1;
       this.version = -1;
@@ -221,10 +222,6 @@ define('pgadmin.dashboard', [
       // Load the default welcome dashboard
       var url = url_for('dashboard.index');
 
-      /* Store the chart objects, refresh freq and next refresh time */
-      this.chart_store = {};
-      this.charts_poller_int_id = -1;
-
       var dashboardPanel = pgBrowser.panels['dashboard'].panel;
       if (dashboardPanel) {
         var div = dashboardPanel.layout().scene().find('.pg-panel-content');
@@ -355,11 +352,9 @@ define('pgadmin.dashboard', [
                   $(dashboardPanel).data('server_status') == false
                 )
               ) {
+                this.chartsDomObj && this.chartsDomObj.unmount();
                 $(div).empty();
 
-                /* Clear all the charts previous dashboards */
-                self.clearChartFromStore();
-
                 let ajaxHook = function() {
                   $.ajax({
                     url: url,
@@ -393,14 +388,8 @@ define('pgadmin.dashboard', [
                 $(dashboardPanel).data('server_status', true);
               }
             } else {
+              this.chartsDomObj && this.chartsDomObj.unmount();
               $(div).empty();
-              if (
-                !_.isUndefined(itemData.connected) &&
-                  itemData.connected !== true
-              ) {
-                /* Clear all the charts previous dashboards */
-                self.clearChartFromStore();
-              }
               $(div).html(
                 '<div class="pg-panel-message" role="alert">' + gettext('Please connect to the selected server to view the dashboard.') + '</div>'
               );
@@ -413,218 +402,6 @@ define('pgadmin.dashboard', [
       }
     },
 
-    // Render the charts
-    renderCharts: function(charts_config) {
-
-      let self = this,
-        tooltipFormatter = function(refresh, currVal) {
-          return(`Seconds ago: ${parseInt(currVal.x * refresh)}</br>
-                  Value: ${currVal.y}`);
-        },
-        curr_epoch=commonUtils.getEpoch();
-
-      self.stopChartsPoller();
-
-      charts_config.map((chart_config) => {
-        if(self.chart_store[chart_config.chart_name]
-          && self.old_preferences[chart_config.refresh_pref_name] !=
-            self.preferences[chart_config.refresh_pref_name]) {
-          self.clearChartFromStore(chart_config.chart_name);
-        }
-
-        if(self.chart_store[chart_config.chart_name]) {
-          let chart_obj = self.chart_store[chart_config.chart_name].chart_obj;
-          chart_obj.setOptions(chart_config.options, false);
-          chart_obj.setTooltipFormatter(
-            tooltipFormatter.bind(null, self.preferences[chart_config.refresh_pref_name])
-          );
-        }
-
-        if(!self.chart_store[chart_config.chart_name]) {
-          let chart_obj = new charting.Chart(chart_config.container, chart_config.options);
-
-          chart_obj.setTooltipFormatter(
-            tooltipFormatter.bind(null, self.preferences[chart_config.refresh_pref_name])
-          );
-
-          chart_obj.setOtherData('counter', chart_config.counter);
-
-          self.chart_store[chart_config.chart_name] = {
-            'chart_obj' : chart_obj,
-            'refresh_on': curr_epoch,
-            'refresh_rate': self.preferences[chart_config.refresh_pref_name],
-          };
-        }
-      });
-
-      self.startChartsPoller(self.chart_store, self.sid, self.did);
-    },
-
-    getStatsUrl: function(sid=-1, did=-1, chart_names=[]) {
-      let base_url = url_for('dashboard.dashboard_stats');
-      base_url += '/' + sid;
-      base_url += (did > 0) ? ('/' + did) : '';
-      base_url += '?chart_names=' + chart_names.join(',');
-      return base_url;
-    },
-
-    updateChart: function(chart_obj, new_data){
-      // Dataset format:
-      // [
-      //     { data: [[0, y0], [1, y1]...], label: 'Label 1', [options] },
-      //     { data: [[0, y0], [1, y1]...], label: 'Label 2', [options] },
-      //     { data: [[0, y0], [1, y1]...], label: 'Label 3', [options] }
-      // ]
-      let dataset = chart_obj.getOtherData('dataset') || [],
-        counter_prev_data = chart_obj.getOtherData('counter_prev_data') || new_data,
-        counter = chart_obj.getOtherData('counter') || false;
-
-      if (dataset.length == 0) {
-        // Create the initial data structure
-        for (let label in new_data) {
-          dataset.push({
-            'data': [
-              [0, counter ? (new_data[label] - counter_prev_data[label]) : new_data[label]],
-            ],
-            'label': label,
-          });
-        }
-      } else {
-        Object.keys(new_data).forEach((label, label_ind) => {
-          // Push new values onto the existing data structure
-          // If this is a counter stat, we need to subtract the previous value
-          if (!counter) {
-            dataset[label_ind]['data'].unshift([0, new_data[label]]);
-          } else {
-            // Store the current value, minus the previous one we stashed.
-            // It's possible the tab has been reloaded, in which case out previous values are gone
-            if (_.isUndefined(counter_prev_data))
-              return;
-
-            dataset[label_ind]['data'].unshift([0, new_data[label] - counter_prev_data[label]]);
-          }
-
-          // Reset the time index to get a proper scrolling display
-          for (var time_ind = 0; time_ind < dataset[label_ind]['data'].length; time_ind++) {
-            dataset[label_ind]['data'][time_ind][0] = time_ind;
-          }
-        });
-        counter_prev_data = new_data;
-      }
-
-      // Remove old data points
-      for (let label_ind = 0; label_ind < dataset.length; label_ind++) {
-        if (dataset[label_ind]['data'].length > 101) {
-          dataset[label_ind]['data'].pop();
-        }
-      }
-
-      chart_obj.setOtherData('dataset', dataset);
-      chart_obj.setOtherData('counter_prev_data', counter_prev_data);
-
-      if (chart_obj.isInPage()) {
-        if (chart_obj.isVisible()) {
-          chart_obj.draw(dataset);
-        }
-      } else {
-        return;
-      }
-    },
-
-    stopChartsPoller: function() {
-      clearInterval(this.charts_poller_int_id);
-    },
-
-    startChartsPoller: function(chart_store, sid, did) {
-      let self = this;
-      /* polling will the greatest common divisor of the refresh rates*/
-      let poll_interval = commonUtils.getGCD(
-        Object.values(chart_store).map(item => item.refresh_rate)
-      );
-      const WAIT_COUNTER = 3;
-      let last_poll_wait_counter = 0;
-      let resp_not_received_counter = 0;
-
-      /* Stop if running, only one poller lives */
-      self.stopChartsPoller();
-
-      var thePollingFunc = function() {
-        let curr_epoch = commonUtils.getEpoch();
-        let chart_names_to_get = [];
-
-        for(let chart_name in chart_store) {
-          /* when its time to get the data */
-          if(chart_store[chart_name].refresh_on <= curr_epoch) {
-            /* set the next trigger point */
-            chart_store[chart_name].refresh_on = curr_epoch + chart_store[chart_name].refresh_rate;
-            chart_names_to_get.push(chart_name);
-          }
-        }
-
-        /* If none of the chart wants data, don't trouble
-         * If response not received from prev poll, don't trouble !!
-         */
-        if(chart_names_to_get.length == 0 || last_poll_wait_counter > 0 || resp_not_received_counter >= WAIT_COUNTER) {
-          /* reduce the number of tries, request should be sent if last_poll_wait_counter
-           * completes WAIT_COUNTER times.*/
-          last_poll_wait_counter--;
-          return;
-        }
-
-        var path = self.getStatsUrl(sid, did, chart_names_to_get);
-        resp_not_received_counter++;
-        $.ajax({
-          url: path,
-          type: 'GET',
-        })
-          .done(function(resp) {
-            for(let chart_name in resp) {
-              let chart_obj = chart_store[chart_name].chart_obj;
-              $(chart_obj.getContainer()).removeClass('graph-error');
-              self.updateChart(chart_obj, resp[chart_name]);
-            }
-          })
-          .fail(function(xhr) {
-            let err = '';
-            let msg = '';
-            let cls = 'info';
-
-            if (xhr.readyState === 0) {
-              msg = gettext('Not connected to the server or the connection to the server has been closed.');
-            } else {
-              err = JSON.parse(xhr.responseText);
-              msg = err.errormsg;
-
-              // If we get a 428, it means the server isn't connected
-              if (xhr.status === 428) {
-                if (_.isUndefined(msg) || _.isNull(msg)) {
-                  msg = gettext('Please connect to the selected server to view the graph.');
-                }
-              } else {
-                msg = gettext('An error occurred whilst rendering the graph.');
-                cls = 'error';
-              }
-            }
-
-            for(let chart_name in chart_store) {
-              let chart_obj = chart_store[chart_name].chart_obj;
-              $(chart_obj.getContainer()).addClass('graph-error');
-              $(chart_obj.getContainer()).html(
-                '<div class="pg-panel-' + cls + ' pg-panel-message" role="alert">' + msg + '</div>'
-              );
-            }
-          })
-          .always(function() {
-            last_poll_wait_counter = 0;
-            resp_not_received_counter--;
-          });
-        last_poll_wait_counter = WAIT_COUNTER;
-      };
-      /* Execute once for the first time as setInterval will not do */
-      thePollingFunc();
-      self.charts_poller_int_id = setInterval(thePollingFunc, poll_interval * 1000);
-    },
-
     // Handler function to support the "Add Server" link
     add_new_server: function() {
       if (pgBrowser && pgBrowser.tree) {
@@ -759,23 +536,17 @@ define('pgadmin.dashboard', [
       });
     },
 
-    clearChartFromStore: function(chartName) {
-      var self = this;
-      if(!chartName){
-        self.stopChartsPoller();
-        _.each(self.chart_store, function(chart, key) {
-          delete self.chart_store[key];
-        });
-      }
-      else {
-        delete self.chart_store[chartName];
-      }
-    },
-
     // Rock n' roll on the dashboard
     init_dashboard: function() {
       let self = this;
 
+      this.chartsDomObj = new ChartsDOM.default(
+        document.getElementById('new-dashboard-graphs'),
+        self.preferences,
+        self.sid,
+        self.did
+      );
+
       /* Cache may take time to load for the first time
        * Keep trying till available
        */
@@ -796,81 +567,14 @@ define('pgadmin.dashboard', [
       pgBrowser.onPreferencesChange('dashboards', function() {
         self.reflectPreferences();
       });
-
     },
 
     reflectPreferences: function() {
       var self = this;
-      var tickColor = getComputedStyle(document.documentElement).getPropertyValue('--border-color');
-
-      /* We will use old preferences for selective graph updates on preference change */
-      if(self.preferences) {
-        self.old_preferences = self.preferences;
-        self.preferences = pgWindow.default.pgAdmin.Browser.get_preferences_for_module('dashboards');
-      }
-      else {
-        self.preferences = pgWindow.default.pgAdmin.Browser.get_preferences_for_module('dashboards');
-        self.old_preferences = self.preferences;
-      }
+      self.preferences = pgWindow.default.pgAdmin.Browser.get_preferences_for_module('dashboards');
+      this.chartsDomObj.reflectPreferences(self.preferences);
 
       if(is_server_dashboard || is_database_dashboard) {
-        /* Common things can come here */
-        var div_sessions = $('.dashboard-container').find('#graph-sessions')[0];
-        var div_tps = $('.dashboard-container').find('#graph-tps')[0];
-        var div_ti = $('.dashboard-container').find('#graph-ti')[0];
-        var div_to = $('.dashboard-container').find('#graph-to')[0];
-        var div_bio = $('.dashboard-container').find('#graph-bio')[0];
-        var options_line = {
-          parseFloat: false,
-          xaxis: {
-            min: 100,
-            max: 0,
-            autoscale: 0,
-          },
-          yaxis: {
-            autoscale: 1,
-          },
-          grid: {
-            color: 'transparent',
-            tickColor: tickColor,
-          },
-        };
-
-        if(self.preferences.graph_data_points) {
-          /* Merge data points related options */
-          options_line = {
-            ...options_line,
-            ...{
-              points: {
-                show:true,
-                radius: 1,
-                hitRadius: 3,
-              },
-            },
-          };
-        }
-
-        if(self.preferences.graph_mouse_track) {
-          /* Merge mouse track related options */
-          options_line = {
-            ...options_line,
-            ...{
-              mouse: {
-                track:true,
-                position: 'sw',
-              },
-            },
-          };
-        }
-
-        if(self.preferences.show_graphs && $('#dashboard-graphs').hasClass('dashboard-hidden')) {
-          $('#dashboard-graphs').removeClass('dashboard-hidden');
-        }
-        else if(!self.preferences.show_graphs) {
-          $('#dashboard-graphs').addClass('dashboard-hidden');
-          self.clearChartFromStore();
-        }
-
         if (self.preferences.show_activity && $('#dashboard-activity').hasClass('dashboard-hidden')) {
           $('#dashboard-activity').removeClass('dashboard-hidden');
         }
@@ -878,46 +582,11 @@ define('pgadmin.dashboard', [
           $('#dashboard-activity').addClass('dashboard-hidden');
         }
 
-        if(self.preferences.show_graphs) {
-          // Render the graphs
-          pgAdmin.Dashboard.renderCharts([{
-            chart_name: 'session_stats',
-            container: div_sessions,
-            options: options_line,
-            counter: false,
-            refresh_pref_name: 'session_stats_refresh',
-          }, {
-            chart_name: 'tps_stats',
-            container: div_tps,
-            options: options_line,
-            counter: true,
-            refresh_pref_name: 'tps_stats_refresh',
-          }, {
-            chart_name: 'ti_stats',
-            container: div_ti,
-            options: options_line,
-            counter: true,
-            refresh_pref_name: 'ti_stats_refresh',
-          }, {
-            chart_name: 'to_stats',
-            container: div_to,
-            options: options_line,
-            counter: true,
-            refresh_pref_name: 'to_stats_refresh',
-          }, {
-            chart_name: 'bio_stats',
-            container: div_bio,
-            options: options_line,
-            counter: true,
-            refresh_pref_name: 'bio_stats_refresh',
-          }]);
-        }
-
-        if(!self.preferences.show_graphs && !self.preferences.show_activity) {
-          $('#dashboard-none-show').removeClass('dashboard-hidden');
+        if (self.preferences.show_activity && $('#dashboard-activity').hasClass('dashboard-hidden')) {
+          $('#dashboard-activity').removeClass('dashboard-hidden');
         }
-        else {
-          $('#dashboard-none-show').addClass('dashboard-hidden');
+        else if(!self.preferences.show_activity) {
+          $('#dashboard-activity').addClass('dashboard-hidden');
         }
 
         /* Dashboard specific preferences can be updated in the
diff --git a/web/pgadmin/dashboard/static/js/dashboard_components.js b/web/pgadmin/dashboard/static/js/dashboard_components.js
new file mode 100644
index 000000000..f6aa35e94
--- /dev/null
+++ b/web/pgadmin/dashboard/static/js/dashboard_components.js
@@ -0,0 +1,65 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+
+export function ChartContainer(props) {
+  return (
+    <div className="card dashboard-graph" role="object-document" tabIndex="0" aria-labelledby={props.id}>
+      <div className="card-header">
+        <div className="d-flex">
+          <div id={props.id}>{props.title}</div>
+          <div className="ml-auto my-auto legend" ref={props.legendRef}></div>
+        </div>
+      </div>
+      <div className="card-body dashboard-graph-body">
+        <div className={'chart-wrapper ' + (props.errorMsg ? 'd-none': '')}>
+          {props.children}
+        </div>
+        <ChartError message={props.errorMsg} />
+      </div>
+    </div>
+  );
+}
+ChartContainer.propTypes = {
+  id: PropTypes.string.isRequired,
+  title: PropTypes.string.isRequired,
+  legendRef: PropTypes.oneOfType([
+    PropTypes.func,
+    PropTypes.shape({ current: PropTypes.any }),
+  ]).isRequired,
+  children: PropTypes.node.isRequired,
+  errorMsg: PropTypes.string,
+};
+
+export function ChartError(props) {
+  if(props.message === null) {
+    return  <></>;
+  }
+  return (
+    <div className="pg-panel-error pg-panel-message" role="alert">{props.message}</div>
+  );
+}
+
+ChartError.propTypes = {
+  message: PropTypes.string,
+};
+
+export function DashboardRow({children}) {
+  return (
+    <div className="row dashboard-row">{children}</div>
+  );
+}
+DashboardRow.propTypes = {
+  children: PropTypes.node.isRequired,
+};
+
+export function DashboardRowCol({breakpoint, parts, children}) {
+  return (
+    <div className={`col-${breakpoint}-${parts}`}>{children}</div>
+  );
+}
+
+DashboardRowCol.propTypes = {
+  breakpoint: PropTypes.oneOf(['xs', 'sm', 'md', 'lg', 'xl']).isRequired,
+  parts: PropTypes.number.isRequired,
+  children: PropTypes.node.isRequired,
+};
\ No newline at end of file
diff --git a/web/pgadmin/static/js/chartjs/index.js b/web/pgadmin/static/js/chartjs/index.js
new file mode 100644
index 000000000..a336f7626
--- /dev/null
+++ b/web/pgadmin/static/js/chartjs/index.js
@@ -0,0 +1,70 @@
+import React, { useEffect } from 'react';
+import Chart from 'chart.js';
+import PropTypes from 'prop-types';
+
+const defaultOptions = {
+  maintainAspectRatio: false,
+  elements: {
+    line: {
+      tension: 0,
+      borderWidth: 2,
+      fill: false,
+    },
+  },
+  layout: {
+    padding: 8,
+  },
+  hover: {
+    animationDuration:0,
+  },
+};
+
+export default function BaseChart({type='line', options, data, ...props}) {
+  const chartRef = React.useRef();
+  const chartObj = React.useRef();
+  let optionsMerged = Chart.helpers.configMerge(defaultOptions, options);
+
+  useEffect(()=>{
+    let chartContext = chartRef.current.getContext('2d');
+    chartObj.current = new Chart(chartContext, {
+      type: type,
+      data: data,
+      options: optionsMerged,
+    });
+    props.onInit && props.onInit(chartObj.current);
+  }, []);
+
+  useEffect(()=>{
+    if(typeof(chartObj.current) != 'undefined') {
+      chartObj.current.data = data;
+      for(let i=0; i<chartObj.current.data.datasets.length; i++) {
+        chartObj.current.data.datasets[i] = {
+          ...chartObj.current.data.datasets[i],
+          ...data.datasets[i],
+        };
+      }
+      chartObj.current.options = optionsMerged;
+      chartObj.current.update(props.updateOptions || {});
+      props.onUpdate && props.onUpdate(chartObj.current);
+    }
+  }, [data, options]);
+
+  return (
+    <canvas ref={chartRef}></canvas>
+  );
+}
+
+BaseChart.propTypes = {
+  type: PropTypes.string.isRequired,
+  data: PropTypes.object.isRequired,
+  options: PropTypes.object,
+  updateOptions: PropTypes.object,
+  onInit: PropTypes.func,
+  onUpdate: PropTypes.func,
+};
+
+export function LineChart(props) {
+  return (
+    <BaseChart {...props} type='line'/>
+  );
+}
\ No newline at end of file
diff --git a/web/pgadmin/static/js/custom_hooks.js b/web/pgadmin/static/js/custom_hooks.js
new file mode 100644
index 000000000..9163f0d6c
--- /dev/null
+++ b/web/pgadmin/static/js/custom_hooks.js
@@ -0,0 +1,29 @@
+import {useRef, useEffect} from 'react';
+
+/* React hook for setInterval */
+export function useInterval(callback, delay) {
+  const savedCallback = useRef();
+
+  useEffect(() => {
+    savedCallback.current = callback;
+  });
+
+  useEffect(() => {
+    function tick() {
+      savedCallback.current();
+    }
+
+    if(delay > -1) {
+      let id = setInterval(tick, delay);
+      return () => clearInterval(id);
+    }
+  }, [delay]);
+}
+
+export function usePrevious(value) {
+  const ref = useRef();
+  useEffect(() => {
+    ref.current = value;
+  });
+  return ref.current;
+}
\ No newline at end of file
diff --git a/web/regression/javascript/dashboard/graphs_spec.js b/web/regression/javascript/dashboard/graphs_spec.js
new file mode 100644
index 000000000..f3d028f4d
--- /dev/null
+++ b/web/regression/javascript/dashboard/graphs_spec.js
@@ -0,0 +1,169 @@
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import {mount} from 'enzyme';
+import '../helper/enzyme.helper';
+
+import Graphs, {GraphsWrapper} from '../../../pgadmin/dashboard/static/js/Graphs';
+import {X_AXIS_LENGTH, POINT_SIZE, transformData, legendCallback,
+  getStatsUrl, statsReducer} from '../../../pgadmin/dashboard/static/js/Graphs';
+
+describe('Graphs.js', ()=>{
+  it('transformData', ()=>{
+    expect(transformData({'Label1': [], 'Label2': []}, 1)).toEqual({
+      labels: [...Array(X_AXIS_LENGTH).keys()],
+      datasets: [{
+        label: 'Label1',
+        data: [],
+        borderColor: '#00BCD4',
+        backgroundColor: '#00BCD4',
+        pointHitRadius: POINT_SIZE,
+      },{
+        label: 'Label2',
+        data: [],
+        borderColor: '#9CCC65',
+        backgroundColor: '#9CCC65',
+        pointHitRadius: POINT_SIZE,
+      }],
+      refreshRate: 1,
+    });
+  });
+
+  it('legendCallback', ()=>{
+    expect(legendCallback({
+      id: 1,
+      data: {
+        datasets: [{
+          label: 'Label1',
+          backgroundColor: '#00BCD4',
+        },{
+          label: 'Label2',
+          backgroundColor: '#9CCC65',
+        }],
+      },
+    })).toEqual([
+      '<div class="1-legend d-flex">',
+      '<div class="legend-value"><span style="background-color:#00BCD4">&nbsp;&nbsp;&nbsp;&nbsp;</span>',
+      '<span class="legend-label">Label1</span>',
+      '</div>',
+      '<div class="legend-value"><span style="background-color:#9CCC65">&nbsp;&nbsp;&nbsp;&nbsp;</span>',
+      '<span class="legend-label">Label2</span>',
+      '</div>',
+      '</div>',
+    ].join(''));
+  });
+
+  describe('getStatsUrl', ()=>{
+    it('for server', ()=>{
+      expect(getStatsUrl(432, -1, ['chart1'])).toEqual('/dashboard/dashboard_stats/432?chart_names=chart1');
+    });
+    it('for database', ()=>{
+      expect(getStatsUrl(432, 123, ['chart1'])).toEqual('/dashboard/dashboard_stats/432/123?chart_names=chart1');
+    });
+    it('for multiple graphs', ()=>{
+      expect(getStatsUrl(432, 123, ['chart1', 'chart2'])).toEqual('/dashboard/dashboard_stats/432/123?chart_names=chart1,chart2');
+    });
+  });
+
+  describe('statsReducer', ()=>{
+    it('with incoming no counter', ()=>{
+      let state = {
+        'Label1': [], 'Label2': [],
+      };
+      let action = {
+        incoming: {
+          'Label1': 1, 'Label2': 2,
+        },
+      };
+      let newState = {
+        'Label1': [1], 'Label2': [2],
+      };
+      state = statsReducer(state, action);
+      expect(state).toEqual(newState);
+    });
+
+    it('with incoming with counter', ()=>{
+      let state = {
+        'Label1': [1], 'Label2': [2],
+      };
+      let action = {
+        incoming: {
+          'Label1': 1, 'Label2': 3,
+        },
+        counter: true,
+        counterData: {'Label1': 1, 'Label2': 2},
+      };
+      let newState = {
+        'Label1': [0, 1], 'Label2': [1, 2],
+      };
+      state = statsReducer(state, action);
+      expect(state).toEqual(newState);
+    });
+
+    it('with reset', ()=>{
+      let state = {
+        'Label1': [0, 1], 'Label2': [1, 2],
+      };
+      let action = {
+        reset: {
+          'Label1': [2], 'Label2': [2],
+        },
+      };
+      let newState = {
+        'Label1': [2], 'Label2': [2],
+      };
+      state = statsReducer(state, action);
+      expect(state).toEqual(newState);
+    });
+  });
+
+  describe('<Graphs /> component', ()=>{
+    let graphComp = null;
+    let sid = 1;
+    let did = 1;
+    beforeEach(()=>{
+      jasmineEnzyme();
+      let dashboardPref = {
+        session_stats_refresh: 1,
+        tps_stats_refresh: 1,
+        ti_stats_refresh: 1,
+        to_stats_refresh: 1,
+        bio_stats_refresh: 1,
+        show_graphs: true,
+        graph_data_points: true,
+        graph_mouse_track: true,
+      };
+
+      graphComp = mount(<Graphs preferences={dashboardPref} sid={sid} did={did} enablePoll={false} />);
+    });
+
+    it('GraphsWrapper is rendered',  (done)=>{
+      let found = graphComp.find(GraphsWrapper);
+      expect(found.length).toBe(1);
+      done();
+    });
+
+    it('pollDelay is set',  (done)=>{
+      let found = graphComp.find('[data-testid="graph-poll-delay"]');
+      expect(found).toHaveClassName('d-none');
+      expect(found).toHaveText('1000');
+      done();
+    });
+
+    it('pollDelay on preference update',  (done)=>{
+      let dashboardPref = {
+        session_stats_refresh: 5,
+        tps_stats_refresh: 10,
+        ti_stats_refresh: 5,
+        to_stats_refresh: 10,
+        bio_stats_refresh: 10,
+        show_graphs: true,
+        graph_data_points: true,
+        graph_mouse_track: true,
+      };
+      graphComp.setProps({preferences: dashboardPref});
+      let found = graphComp.find('[data-testid="graph-poll-delay"]');
+      expect(found).toHaveText('5000');
+      done();
+    });
+  });
+});
\ No newline at end of file
diff --git a/web/regression/javascript/dashboard/graphs_wrapper_spec.js b/web/regression/javascript/dashboard/graphs_wrapper_spec.js
new file mode 100644
index 000000000..3e9f6f286
--- /dev/null
+++ b/web/regression/javascript/dashboard/graphs_wrapper_spec.js
@@ -0,0 +1,90 @@
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import {mount} from 'enzyme';
+import '../helper/enzyme.helper';
+
+import {GraphsWrapper, X_AXIS_LENGTH, POINT_SIZE} from '../../../pgadmin/dashboard/static/js/Graphs';
+
+describe('<GraphsWrapper /> component', ()=>{
+  let graphComp = null;
+  let defaultStats = {
+    labels: [...Array(X_AXIS_LENGTH).keys()],
+    datasets: [{
+      label: 'Label1',
+      data: [],
+      borderColor: '#00BCD4',
+      backgroundColor: '#00BCD4',
+      pointHitRadius: POINT_SIZE,
+    },{
+      label: 'Label2',
+      data: [],
+      borderColor: '#9CCC65',
+      backgroundColor: '#9CCC65',
+      pointHitRadius: POINT_SIZE,
+    }],
+    refreshRate: 1,
+  };
+  beforeEach(()=>{
+    jasmineEnzyme();
+    graphComp = mount(<GraphsWrapper sessionStats={defaultStats}
+      tpsStats={defaultStats}
+      tiStats={defaultStats}
+      toStats={defaultStats}
+      bioStats={defaultStats}
+      errorMsg={null}
+      showTooltip={true}
+      showDataPoints={true}
+      isDatabase={false} />);
+  });
+
+  it('graph containers are rendered', (done)=>{
+    let found = graphComp.find('.card.dashboard-graph');
+    expect(found.length).toBe(5);
+    done();
+  });
+
+  it('graph headers are correct', (done)=>{
+    let found = graphComp.find('.card.dashboard-graph');
+    expect(found.at(0)).toIncludeText('Server sessions');
+    expect(found.at(1)).toIncludeText('Transactions per second');
+    expect(found.at(2)).toIncludeText('Tuples in');
+    expect(found.at(3)).toIncludeText('Tuples out');
+    expect(found.at(4)).toIncludeText('Block I/O');
+    done();
+  });
+
+  it('graph headers when database', (done)=>{
+    let found = graphComp.find('.card.dashboard-graph');
+    graphComp.setProps({isDatabase: true});
+    expect(found.at(0)).toIncludeText('Database sessions');
+    done();
+  });
+
+  it('graph body has the canvas', (done)=>{
+    let found = graphComp.find('.card.dashboard-graph .dashboard-graph-body canvas');
+    expect(found.at(0).length).toBe(1);
+    expect(found.at(1).length).toBe(1);
+    expect(found.at(2).length).toBe(1);
+    expect(found.at(3).length).toBe(1);
+    expect(found.at(4).length).toBe(1);
+    done();
+  });
+
+  it('graph body shows the error', (done)=>{
+    graphComp.setProps({errorMsg: 'Some error occurred'});
+    let found = graphComp.find('.card.dashboard-graph .dashboard-graph-body .chart-wrapper');
+    expect(found.at(0)).toHaveClassName('d-none');
+    expect(found.at(1)).toHaveClassName('d-none');
+    expect(found.at(2)).toHaveClassName('d-none');
+    expect(found.at(3)).toHaveClassName('d-none');
+    expect(found.at(4)).toHaveClassName('d-none');
+
+    found = graphComp.find('.card.dashboard-graph .dashboard-graph-body .pg-panel-error.pg-panel-message');
+    expect(found.at(0)).toIncludeText('Some error occurred');
+    expect(found.at(1)).toIncludeText('Some error occurred');
+    expect(found.at(2)).toIncludeText('Some error occurred');
+    expect(found.at(3)).toIncludeText('Some error occurred');
+    expect(found.at(4)).toIncludeText('Some error occurred');
+    done();
+  });
+});
\ No newline at end of file
diff --git a/web/regression/javascript/fake_endpoints.js b/web/regression/javascript/fake_endpoints.js
index 157a34863..806f59001 100644
--- a/web/regression/javascript/fake_endpoints.js
+++ b/web/regression/javascript/fake_endpoints.js
@@ -21,5 +21,6 @@ define(function () {
     'datagrid.panel': '/panel/<int:trans_id>',
     'search_objects.types': '/search_objects/types/<int:sid>/<int:did>',
     'search_objects.search': '/search_objects/search/<int:sid>/<int:did>',
+    'dashboard.dashboard_stats': '/dashboard/dashboard_stats',
   };
 });
diff --git a/web/regression/javascript/helper/enzyme.helper.js b/web/regression/javascript/helper/enzyme.helper.js
new file mode 100644
index 000000000..dbe9b4cab
--- /dev/null
+++ b/web/regression/javascript/helper/enzyme.helper.js
@@ -0,0 +1,4 @@
+import Enzyme from 'enzyme';
+import Adapter from 'enzyme-adapter-react-16';
+
+Enzyme.configure({adapter: new Adapter()});
\ No newline at end of file
